/*
======================================================================
    Tool to set rotation limits on all selected items.
It can also control stiffness.
    Max value on the first item and get smaller with each item.
    Till it has reached the last item with the minimum value.

www.Steelronin.com
Scott@steelronin.com
======================================================================
*/
 
scriptName = "Set limits v0.1.3";
copyright = "Copyright (c) 2003 Scott lange";

//Tom Speed is the man who makes this all posible.

/*
v0.1.1: change some interface settings
v0.1.2: changed stiffness min/max to max/min to make more sence
    and work in the corect order
v0.1.3: finished the stiffness since i completly forgeot to.
    And in the proccess ended up redoing the entire interface. 
*/ 

@version 2.2
@warnings
@name SR_Set_limits
@script generic

// globals

cMin;
cMax;
AMin = -30;
AMax = 30;
cH;
cP;
cB;
c4;
c5;
c6;
c7;
c8;
c9;
c10;
c11;
c12;
sMin;
sMax;
SMin = 1;
SMax = 1;
sH;
sP;
sB;
c16;
c17;
c18;
c19;
c20;
c21;
c22;
c23;
c24;
Alll = 0;
Alls = 0;

generic
{
    c1  = true;
    c2  = -30;
    c3  = 30;
    c4  = 1;
    c5  = 1;
    c6  = 1;
    c7;
    c8;
    c9;
    c10;
    c11;
    c12;
    c13 = 0;
    c14 = 1;
    c15 = 1;
    c16 = 1;
    c17 = 1;
    c18 = 1;
    c19 = 1;
    c20 = 1;
    c21 = 1;
    c22 = 1;
    c23 = 1;
    c24 = 1;
    c25 = 0;
     
    sList = Scene().getSelect();
    if(sList == nil) return;

    // reverse slist order
    listcopy = sList;
    for(a=1;a<=size(listcopy);a++)
    	sList[(size(listcopy)+1) - a]=listcopy[a];

    reqbegin(scriptName);
    reqsize(300,300);
    
    // grab global var for refresh
    cMin = AMin; 
    cMax = AMax;
    sMin = SMin;
    sMax = SMax;
    cH = Alll;
    cP = Alll;
    cB = Alll;
    sH = Alls;
    sP = Alls;
    sB = Alls;
    
    c1  = ctlstate("All Limits",Alll,100,"callback_All");        
    c2  = ctlminislider("Min",AMin,-180,0);
        ctlrefresh(c2,"lMinrefresh");   
    c3  = ctlminislider("Max",AMax,0,180);
        ctlrefresh(c3,"lMaxrefresh");
    s1 = ctlsep(0,320);
        ctlposition(s1,0,105,320,5);
            c4  = ctlstate("Heading",cH,110,"Hstate");
    c5  = ctlstate("Pitch",cP,110,"Pstate");
    c6  = ctlstate("Bank",cB,110,"Bstate");
        ctlrefresh(c1,"AllltoggleOn");
        c7  = ctlminislider("Min",cMin,-180,0); 
    c8  = ctlminislider("Max",cMax,0,180);
    c9  = ctlminislider("Min",cMin,-180,0);
    c10 = ctlminislider("Max",cMax,0,180);
    c11 = ctlminislider("Min",cMin,-180,0);
    c12 = ctlminislider("Max",cMax,0,180);
    c13  = ctlstate("All Stiffness",Alls,100,"callback_sAll");
    c14  = ctlminislider("Min",SMin,-180,0);
        ctlrefresh(c14,"sMinrefresh");
    c15  = ctlminislider("Max",SMax,0,180);
        ctlrefresh(c15,"sMaxrefresh");
    c16  = ctlstate("Stiffness H",sH,110,"Hsstate");
    c17  = ctlstate("Stiffness P",sP,110,"Psstate");
    c18  = ctlstate("Stiffness B",sB,110,"Bsstate");
        ctlrefresh(c13,"AllstoggleOn");
    c19 = ctlminislider("Min",sMin,0.1,200);
    c20 = ctlminislider("Max",sMax,0.1,200);
    c21 = ctlminislider("Min",sMin,0.1,200);
    c22 = ctlminislider("Max",sMax,0.1,200);
    c23 = ctlminislider("Min",sMin,0.1,200);
    c24 = ctlminislider("Max",sMax,0.1,200);           
    c25 = ctlpopup("Choose Start Axis   ",c25,@"Rotation","Pivot","0,0,0"@);
    
        ctlgroup(c1,c4,c5,c6,c13);
            ctlgroup(c13,c14,c15,c16,c17,c18,c25);
                ctlposition(c1,5,5,70,20);
                    ctlposition(c4,0,25,60,20);
                    ctlposition(c5,0,50,60,20);
                    ctlposition(c6,0,75,60,20);
                    ctlposition(c13,0,105,70,20);
                        ctlposition(c16,5,30,60,20);
                        ctlposition(c17,5,55,60,20);
                        ctlposition(c18,5,80,60,20);
                        ctlposition(c25,5,105,200,20);
                        
        ctlgroup(c2,c7,c9,c11,c14);
            ctlgroup(c14,c19,c21,c23);
                ctlposition(c2,80,5,60,20);
                    ctlposition(c7,0,25,60,20);
                    ctlposition(c9,0,50,60,20);
                    ctlposition(c11,0,75,60,20);
                    ctlposition(c14,0,105,60,20);
                        ctlposition(c19,80,30,60,20);
                        ctlposition(c21,80,55,60,20);
                        ctlposition(c23,80,80,60,20);
        
        ctlgroup(c3,c8,c10,c12,c15);
            ctlgroup(c15,c20,c22,c24);
                ctlposition(c3,180,5,60,20);
                    ctlposition(c8,0,25,60,20);
                    ctlposition(c10,0,50,60,20);
                    ctlposition(c12,0,75,60,20);
                    ctlposition(c15,0,105,60,20);
                        ctlposition(c20,180,30,60,20);
                        ctlposition(c22,180,55,60,20);
                        ctlposition(c24,180,80,60,20); 

        
    if(!reqpost()) return;
    
    lAll    = getvalue(c1);
    lMin    = getvalue(c2);
    lMax    = getvalue(c3);
    ch      = getvalue(c4);
    cp      = getvalue(c5);
    cb      = getvalue(c6);
    hlMin   = getvalue(c7);
    hlMax   = getvalue(c8);
    plMin   = getvalue(c9);
    plMax   = getvalue(c10);
    blMin   = getvalue(c11);
    blMax   = getvalue(c12);
    sAll    = getvalue(c13);
    smi      = getvalue(c14);
    sma      = getvalue(c15);
    hs      = getvalue(c16);
    ps      = getvalue(c17);
    bs      = getvalue(c18);
    hsMin   = getvalue(c19);
    hsMax   = getvalue(c20);
    psMin   = getvalue(c21);
    psMax   = getvalue(c22);
    bsMin   = getvalue(c23);
    bsMax   = getvalue(c24);
    uRot    = getvalue(c25);    

    reqend();    

    t = Scene().currenttime;
    n = size(sList);
    i;
    s;
    if(size(sList) == 1)
    {
        Hstep = (hsMax - hsMin) / (size(sList));
        Pstep = (psMax - psMin) / (size(sList));
        Bstep = (bsMax - bsMin) / (size(sList));
    }
    else
    {
    Hstep = (hsMax - hsMin) / (size(sList) - 1);
    Pstep = (psMax - psMin) / (size(sList) - 1);
    Bstep = (bsMax - bsMin) / (size(sList) - 1);
    }
    
    for(i = 1;i <= n;i++){
        obj = sList[i];
        rot = obj.getRotation(t);
        pivR = obj.getPivotRotation(t);
        if(obj.genus == BONE){
            resR = sList[i].restParam(ROTATION);
        }
        SelectItem(obj.id);
        
        //Bones set limits;
        if(obj.genus == BONE){
            if(ch){
                LimitH();
                if(uRot == 1){
                    hl1 = hlMin;
                    hl2 = hlMax;
                }
                if(uRot == 2){
                    hl1 = pivR.h+hlMin;
                    hl2 = pivR.h+hlMax;
                }                
                    else{
                    hl1 = resR.h+hlMin;
                    hl2 = resR.h+hlMax;
                }
                HLimits(hl1,hl2);
            }
            if(cp){
                LimitP();
                if(uRot == 1){
                    pl1 = plMin;
                    pl2 = plMax;
                }
                if(uRot == 2){
                    pl1 = pivR.p+plMin;
                    pl2 = pivR.p+plMax;
                }
                    else{
                    pl1 = resR.p+plMin;
                    pl2 = resR.p+plMax;
                }
                PLimits(pl1,pl2);
            }
            if(cb){
                LimitB();
                if(uRot == 1){
                    bl1 = blMin;
                    bl2 = blMax;
                }
                if(uRot == 2){
                    bl1 = pivR.b+blMin;
                    bl2 = pivR.b+blMax;
                }
                    else{
                    bl1 = resR.b+blMin;
                    bl2 = resR.b+blMax;
                }
                BLimits(bl1,bl2);
            }
        }
        
        //object set limits;
        else{
            if(ch){
                LimitH();
                if(uRot == 1){
                    hl1 = hlMin;
                    hl2 = hlMax;
                }
                if(uRot == 2){
                    hl1 = pivR.h+hlMin;
                    hl2 = pivR.h+hlMax;
                }
                    else{
                    hl1 = rot.h+hlMin;
                    hl2 = rot.h+hlMax;
                }
                HLimits(hl1,hl2);
            }
            if(cp){
                LimitP();
                if(uRot == 1){
                    pl1 = plMin;
                    pl2 = plMax;
                }
                if(uRot == 2){
                    pl1 = pivR.p+plMin;
                    pl2 = pivR.p+plMax;
                }
                    else{
                    pl1 = rot.p+plMin;
                    pl2 = rot.p+plMax;
                }
                PLimits(pl1,pl2);
            }
            if(cb){
                LimitB();
                if(uRot == 1){
                    bl1 = blMin;
                    bl2 = blMax;
                }
                if(uRot == 2){
                    bl1 = pivR.b+blMin;
                    bl2 = pivR.b+blMax;
                }
                    else{
                    bl1 = rot.b+blMin;
                    bl2 = rot.b+blMax;
                }
                BLimits(bl1,bl2);
            }
        }
        if(hs){
            HStiffness(hsMax - ((i - 1) * Hstep));
        }
        if(ps){
            PStiffness(psMax - ((i - 1) * Pstep));
        }
        if(bs){
            BStiffness(bsMax - ((i - 1) * Bstep));
        }
    }
    SelectItem(sList[1].id);
    for(n=2;n<=size(sList);n++)
	    AddToSelection(sList[n].id);
}    
// all the callbacks

lMinrefresh: val
{
    setvalue(c7,val);
    setvalue(c9,val);
    setvalue(c11,val);
}
lMaxrefresh: val
{
    setvalue(c8,val);
    setvalue(c10,val);
    setvalue(c12,val);
}
sMinrefresh: val
{
    setvalue(c19,val);
    setvalue(c21,val);
    setvalue(c23,val);
}
sMaxrefresh: val
{
    setvalue(c20,val);
    setvalue(c22,val);
    setvalue(c24,val);
}

AllltoggleOn: val
{
    setvalue(c4,val);
    setvalue(c5,val);
    setvalue(c6,val);    
}
callback_All: val
{
}
Hstate: val
{
}
Pstate: val
{
}
Bstate: val
{
}
AllstoggleOn: val
{
    setvalue(c16,val);
    setvalue(c17,val);
    setvalue(c18,val); 
}
callback_sAll: val
{ 
}
Hsstate: val
{
}
Psstate: val
{
}
Bsstate: val
{
}    
    

